Subject: Re: [PATCH v2] xfrm: fix memory leak in xfrm_add_acquire()

From: Sabrina Dubroca <[email-masked]>
Date: Tue, 11 Nov 2025 00:07:40 +0100

note: the subject prefix should be [PATCH ipsec vX] for fixes to the
ipsec tree. (sorry, I forgot to mention that in v1)

2025-11-10, 06:41:25 +0000, Zilin Guan wrote:
> The xfrm_add_acquire() function constructs an xfrm policy by calling
> xfrm_policy_construct(). This allocates the policy structure and
> potentially associates a security context and a device policy with it.
> 
> However, at the end of the function, the policy object is freed using
> only kfree() . This skips the necessary cleanup for the security context
> and device policy, leading to a memory leak.
> 
> To fix this, invoke the proper cleanup functions xfrm_dev_policy_delete(),
> xfrm_dev_policy_free(), and security_xfrm_policy_free() before freeing the
> policy object. This approach mirrors the error handling path in
> xfrm_add_policy(), ensuring that all associated resources are correctly
> released.
> 
> Fixes: 980ebd25794f ("[IPSEC]: Sync series - acquire insert")
> Signed-off-by: Zilin Guan <[email-masked]>
> ---
> Changes in v2:
> - Use the correct cleanup functions as per xfrm_add_policy().
> ---
>  net/xfrm/xfrm_user.c | 3 +++
>  1 file changed, 3 insertions(+)

Reviewed-by: Sabrina Dubroca <[email-masked]>

-- 
Sabrina